#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <json>

// Constants.
stock const TASK_AIM = 100
stock const TASK_REMO = 102
stock const Float:INTERVAL = 0.5
new Float:g_flDistance=500.0

new mapdata[256]
new JSON:datajson
new keys[100][16],value[100][64],counts
new mapname[64]
new cvars_message_hint

new iClients_s[MAX_PLAYERS], iAliveNum_s=MAX_PLAYERS

public plugin_init()
	{
		register_plugin("Ultimate Break Message","1.1","CT Spawn")

		// others
		intro_map()
		
		register_clcmd("say /brmsg", "breakmsgsay", ADMIN_SLAY, "<entityid> <name|OFF> OFF for delete the name")
		register_clcmd("say /brshow", "breakmsgshow", ADMIN_SLAY, "<ON|OFF>")
		//cvars
		
		cvars_message_hint = register_cvar("ct_break_message_show_hint", "0") // 0 = disable / 1 = show all  / 2 = show only by command 
		set_task(1.0, "cvar_starter", 106, "", 0, "b")

}

public cvar_starter(tosk){
	if( get_pcvar_num(cvars_message_hint) == 1){
		if (!task_exists(TASK_AIM))
			set_task(INTERVAL, "check_Entity", TASK_AIM, "", 0, "b")
		if(task_exists(TASK_REMO))
			remove_task(TASK_REMO)
	}
	else if( get_pcvar_num(cvars_message_hint) == 2){
		if (!task_exists(TASK_REMO))
			set_task(INTERVAL, "check_Entity2", TASK_REMO, "", 0, "b")
		if(task_exists(TASK_AIM))
			remove_task(TASK_AIM)
	}
	else if( get_pcvar_num(cvars_message_hint) == 0){
		if(task_exists(TASK_AIM))
			remove_task(TASK_AIM)
		if(task_exists(TASK_REMO))
			remove_task(TASK_REMO)
	}
}
public setter_id(id){
	if( get_pcvar_num(cvars_message_hint) == 2){
		new i
		for (i = 0; i < iAliveNum_s; i++){
			if ( iClients_s[i]==0 && is_user_alive(id)){
				iClients_s[i]=id
				break
			}
		}
	}
}
public remover_id(id){
	if( get_pcvar_num(cvars_message_hint) == 2)
	{
		new i
		for (i = 0; i < iAliveNum_s; i++){
			if ( iClients_s[i]==id ){
				iClients_s[i]=0
				break
			}
		}
}
}

public taskidremover(){
	if( get_pcvar_num(cvars_message_hint) == 2){
		new i
		for (i = 0; i < iAliveNum_s; i++){
			if ( iClients_s[i]!=0 && !is_user_alive(iClients_s[i])){
				iClients_s[i]=0
			}
		}
	}
}

public breakmsgshow(id, level, cid){
		if (!cmd_access(id, level, cid, 3))
			{
				return PLUGIN_HANDLED
		}
		new Arg[4],argo[4]
		read_argv(2, Arg, 3)
		if( get_pcvar_num(cvars_message_hint) == 2)
			{
				copy(argo,charsmax(argo),Arg)
				strtolower(argo)
				if(equali(argo[0],"on")){
					setter_id(id)
				}
				else if(equali(argo[0],"off")){
					remover_id(id)
				}
				else{
					console_print(id,"usage : say /brshow <ON|OFF>")
				}
		}
		return PLUGIN_HANDLED
}
public check_Entity2(taskid)
{
	taskidremover()
	if( get_pcvar_num(cvars_message_hint) == 2){
		new id, i
		new bool:checker=false,k[16],v[64]

		for (i = 0; i < iAliveNum_s; i++)
		{
			id = iClients_s[i]
			if(id!=0){
				if (get_user_flags(id) & (ADMIN_BAN | ADMIN_KICK | ADMIN_SLAY)) {
					new iEnt
					if (g_flDistance > 0.0 && !(get_user_aiming(id, iEnt) <= g_flDistance))
						continue

					// func_breakable?
					if (FClassnameIs(iEnt, "func_breakable"))
					{
						// 1: Trigger Only?
						if (entity_get_int(iEnt, EV_INT_spawnflags) & SF_BREAK_TRIGGER_ONLY)
							continue
						checker=false
						for (i=0;i<counts;i++){
							k=keys[i]
							v=value[i]
							if ( (str_to_num(k)==iEnt) && (str_to_num(k)!=0)){
								client_print(id, print_center, "Entity ID : %d^nName : %s",str_to_num(k),v)
								checker=true
								break
							}
						}
						if(checker==false)
							client_print(id, print_center, "Entity ID : %d ^nfor set name type:^n^nsay /brmsg %d ^"wood bridge^"^n^n(this is an example)",iEnt,iEnt)
					}
				}
			}
		}
	}
}

public breakmsgsay(id, level, cid)
	{
		if (!cmd_access(id, level, cid, 4))
			{
				return PLUGIN_HANDLED
		}
		new Arg1[16],Arg2[64],szName[32],arg2t[64]
		read_argv(2, Arg1, 15)
		read_argv(3, Arg2, 63)
		new entityid = str_to_num(Arg1)
		if (entityid==0)
			{
				return PLUGIN_HANDLED
		}
		if (entityid <= -1)
			{
				return PLUGIN_HANDLED
		}
		else{
			intro_map()
			if(datajson!=Invalid_JSON){
				
				if (!equali(Arg2[0],"") && !equali(Arg2[0]," "))
					{
						copy(arg2t,charsmax(arg2t),Arg2)
						strtolower(arg2t)
						if(equali(arg2t[0],"off")){
							json_object_remove(datajson,Arg1)
							if(json_serial_to_file(datajson,mapdata)){
								datajson=json_parse(mapdata,true)
								json_data_loader()
								if (is_user_alive(id) && is_user_connected(id)){
									get_user_name(id, szName, charsmax(szName))
									send_to_admins_change_log2(szName,entityid)
									}
								}
						}
						else{
							json_object_set_string(datajson,Arg1,Arg2)
							if(json_serial_to_file(datajson,mapdata)){
								datajson=json_parse(mapdata,true)
								json_data_loader()
								if (is_user_alive(id) && is_user_connected(id)){
									get_user_name(id, szName, charsmax(szName))
									send_to_admins_change_log(szName,entityid,Arg2)
									}
								}
							
						}
				}
				json_data_loader()
			}
		}

		return PLUGIN_HANDLED
}

public intro_map(){
	get_datadir(mapdata,sizeof mapdata -1)
	formatex(mapdata,255,"%s/CT_Spawn",mapdata)
	if(!dir_exists(mapdata))
        mkdir(mapdata)
	formatex(mapdata,255,"%s/MapsData",mapdata)
	if(!dir_exists(mapdata))
        mkdir(mapdata)
	get_mapname(mapname,sizeof mapname -1)
	formatex(mapdata,255,"%s/%s.json",mapdata,mapname)
	if(file_exists(mapdata)){
		datajson=json_parse(mapdata,true)
		json_data_loader()
	}
	else{
		datajson = json_init_object()
		json_serial_to_file(datajson,mapdata)
	}
	
}

public check_Entity(taskid)
{
	static iClients[MAX_PLAYERS], iAliveNum, id, i
	new bool:checker=false,k[16],v[64]
	get_players(iClients, iAliveNum, "ch")

	for (i = 0; i < iAliveNum; i++)
	{
		id = iClients[i]
		if (get_user_flags(id) & (ADMIN_BAN | ADMIN_KICK | ADMIN_SLAY)) {
			new iEntV
			if (g_flDistance > 0.0 && !(get_user_aiming(id, iEntV) <= g_flDistance))
				continue

			// func_breakable?
			if (FClassnameIs(iEntV, "func_breakable"))
			{
				// 1: Trigger Only?
				if (entity_get_int(iEntV, EV_INT_spawnflags) & SF_BREAK_TRIGGER_ONLY)
					continue
				checker=false
				for (i=0;i<counts;i++){
					k=keys[i]
					v=value[i]
					if ( (str_to_num(k)==iEntV) && (str_to_num(k)!=0)){
						client_print(id, print_center, "Entity ID : %d^nName : %s",str_to_num(k),v)
						checker=true
						break
					}
				}
				if(checker==false)
					client_print(id, print_center, "Entity ID : %d ^nfor set name type:^n^nsay /brmsg %d ^"wood bridge^"^n^n(this is an example)",iEntV,iEntV)
			}
		}
	}
}

public json_data_loader(){
	new i=0,bool:verify=false
	new JSON:backup
	new v[64],k[16]
	while(verify==false){
		if(json_object_get_value_at(datajson,i)!=Invalid_JSON){
			backup=json_object_get_value_at(datajson,i)
			json_get_string(backup,v,charsmax(v))
			json_object_get_name(datajson,i,k,charsmax(k))
			value[i]=v
			keys[i]=k
		}
		else{
			verify=true
		}
		counts=i
		i++
		
	}

}


public send_to_admins_change_log(player_name[],entityid,v[64]) {
		new players[32], num
		get_players(players, num)
		for (new i = 0; i < num; i++) {
			if (is_user_connected(players[i])) {
				if (get_user_flags(players[i]) & (ADMIN_BAN | ADMIN_KICK | ADMIN_SLAY)) {
						client_print_color(players[i],0,"^4( ^1Changes will be updated in the new round ^4)^1")
						client_print_color(players[i],0,"^4%s ^1has change entity id ^4%d^1 to ^4%s^1!",player_name,entityid,v)
				}
			}
		}
}
public send_to_admins_change_log2(player_name[],entityid) {
		new players[32], num
		get_players(players, num)
		for (new i = 0; i < num; i++) {
			if (is_user_connected(players[i])) {
				if (get_user_flags(players[i]) & (ADMIN_BAN | ADMIN_KICK | ADMIN_SLAY)) {
						client_print_color(players[i],0,"^4( ^1Changes will be updated in the new round ^4)^1")
						client_print_color(players[i],0,"^4%s ^1has delete the name of entity id ^4%d^1!",player_name,entityid)
				}
			}
		}
}
public ct_enitityname(a[],str[],len){
	new b[64]=""
	json_object_get_string(datajson,a,b,charsmax(b))
	if (strlen(b)!=0){
		copy(str,len,b)
		return 1
	}
	else{
		copy(str,len,"")
		return 0
	}

}

public bool:FClassnameIs(const entityIndex, const className[]){
	new classname[32]
	entity_get_string(entityIndex, EV_SZ_classname, classname, charsmax(classname))
	if(equali(classname[0],className[0]))
		return true
	else
		return false
}